Magisk/scripts/magisk_uninstaller.sh

158 lines
3.8 KiB
Bash
Raw Normal View History

2018-06-27 00:00:01 +02:00
#MAGISK
############################################
2017-06-03 18:03:36 +02:00
#
2018-08-09 12:13:07 +02:00
# Magisk Uninstaller
2017-06-03 18:03:36 +02:00
# by topjohnwu
2017-07-24 20:02:19 +02:00
#
############################################
2017-06-03 18:03:36 +02:00
##############
2018-06-27 00:00:01 +02:00
# Preparation
##############
2018-06-27 00:00:01 +02:00
# This path should work in any cases
TMPDIR=/dev/tmp
INSTALLER=$TMPDIR/install
CHROMEDIR=$INSTALLER/chromeos
PERSISTDIR=/sbin/.magisk/mirror/persist
2018-06-27 00:00:01 +02:00
# Default permissions
umask 022
2017-07-09 18:17:34 +02:00
2018-06-27 00:00:01 +02:00
OUTFD=$2
ZIP=$3
2017-02-05 20:22:37 +01:00
2018-06-27 00:00:01 +02:00
if [ ! -f $INSTALLER/util_functions.sh ]; then
echo "! Unable to extract zip file!"
exit 1
fi
2018-06-27 00:00:01 +02:00
# Load utility functions
. $INSTALLER/util_functions.sh
2018-08-29 04:03:12 +02:00
setup_flashable
2017-09-15 21:48:58 +02:00
print_title "Magisk Uninstaller"
2018-06-27 00:00:01 +02:00
is_mounted /data || mount /data || abort "! Unable to mount partitions"
is_mounted /cache || mount /cache 2>/dev/null
2018-06-26 16:41:03 +02:00
mount_partitions
2018-06-27 00:00:01 +02:00
api_level_arch_detect
ui_print "- Device platform: $ARCH"
MAGISKBIN=$INSTALLER/$ARCH32
mv $CHROMEDIR $MAGISKBIN
chmod -R 755 $MAGISKBIN
check_data
$DATA_DE || abort "! Cannot access /data, please uninstall with Magisk Manager"
$BOOTMODE || recovery_actions
run_migrations
2018-06-27 00:00:01 +02:00
############
2018-06-27 00:00:01 +02:00
# Uninstall
############
2018-06-27 00:00:01 +02:00
get_flags
2018-06-26 16:41:03 +02:00
find_boot_image
[ -e $BOOTIMAGE ] || abort "! Unable to detect boot image"
2019-02-24 08:11:11 +01:00
ui_print "- Found target image: $BOOTIMAGE"
2018-06-26 16:41:03 +02:00
[ -z $DTBOIMAGE ] || ui_print "- Found dtbo image: $DTBOIMAGE"
2017-09-15 21:48:58 +02:00
cd $MAGISKBIN
2017-02-05 20:22:37 +01:00
2018-06-26 16:41:03 +02:00
CHROMEOS=false
2017-02-05 20:22:37 +01:00
2017-09-06 10:13:23 +02:00
ui_print "- Unpacking boot image"
./magiskboot unpack "$BOOTIMAGE"
2017-12-11 20:04:55 +01:00
2017-07-18 09:07:39 +02:00
case $? in
1 )
abort "! Unsupported/Unknown image format"
2017-07-18 09:07:39 +02:00
;;
2018-08-09 12:13:07 +02:00
2 )
2017-12-11 20:04:55 +01:00
ui_print "- ChromeOS boot image detected"
2017-07-18 09:07:39 +02:00
CHROMEOS=true
;;
esac
2017-02-05 20:22:37 +01:00
2017-03-12 11:13:58 +01:00
# Detect boot image state
2017-09-15 21:48:58 +02:00
ui_print "- Checking ramdisk status"
if [ -e ramdisk.cpio ]; then
./magiskboot cpio ramdisk.cpio test
STATUS=$?
else
# Stock A only system-as-root
STATUS=0
fi
case $((STATUS & 3)) in
2017-07-09 18:17:34 +02:00
0 ) # Stock boot
ui_print "- Stock boot image detected"
2017-03-12 11:13:58 +01:00
;;
2018-08-09 12:13:07 +02:00
1 ) # Magisk patched
ui_print "- Magisk patched image detected"
2017-03-12 11:13:58 +01:00
# Find SHA1 of stock boot image
SHA1=`./magiskboot cpio ramdisk.cpio sha1 2>/dev/null`
BACKUPDIR=/data/magisk_backup_$SHA1
if [ -d $BACKUPDIR ]; then
2018-06-27 00:00:01 +02:00
ui_print "- Restoring stock boot image"
flash_image $BACKUPDIR/boot.img.gz $BOOTIMAGE
for name in dtb dtbo; do
[ -f $BACKUPDIR/${name}.img.gz ] || continue
IMAGE=`find_block $name$SLOT`
[ -z $IMAGE ] && continue
ui_print "- Restoring stock $name image"
flash_image $BACKUPDIR/${name}.img.gz $IMAGE
done
2018-06-27 00:00:01 +02:00
else
2017-09-06 10:13:23 +02:00
ui_print "! Boot image backup unavailable"
ui_print "- Restoring ramdisk with internal backup"
./magiskboot cpio ramdisk.cpio restore
if ! ./magiskboot cpio ramdisk.cpio "exists init.rc"; then
# A only system-as-root
rm -f ramdisk.cpio
fi
./magiskboot repack $BOOTIMAGE
2017-09-27 09:26:21 +02:00
# Sign chromeos boot
$CHROMEOS && sign_chromeos
2018-08-10 12:59:14 +02:00
ui_print "- Flashing restored boot image"
flash_image new-boot.img $BOOTIMAGE || abort "! Insufficient partition size"
2017-03-12 11:13:58 +01:00
fi
;;
2 ) # Unsupported
ui_print "! Boot image patched by unsupported programs"
2017-09-06 10:13:23 +02:00
abort "! Cannot uninstall"
2017-03-12 11:13:58 +01:00
;;
esac
2017-09-06 10:13:23 +02:00
ui_print "- Removing Magisk files"
rm -rf \
/cache/*magisk* /cache/unblock /data/*magisk* /data/cache/*magisk* /data/property/*magisk* \
/data/Magisk.apk /data/busybox /data/custom_ramdisk_patch.sh /data/adb/*magisk* \
/data/adb/post-fs-data.d /data/adb/service.d /data/adb/modules* $PERSISTDIR/magisk 2>/dev/null
2017-02-05 20:22:37 +01:00
2018-06-26 16:41:03 +02:00
if [ -f /system/addon.d/99-magisk.sh ]; then
mount -o rw,remount /system
rm -f /system/addon.d/99-magisk.sh
fi
2018-06-27 00:00:01 +02:00
cd /
if $BOOTMODE; then
ui_print "**********************************************"
ui_print "* Magisk Manager will uninstall itself, and *"
ui_print "* the device will reboot after a few seconds *"
ui_print "**********************************************"
(sleep 8; /system/bin/reboot)&
else
rm -rf /data/user*/*/*magisk* /data/app/*magisk*
recovery_cleanup
ui_print "- Done"
fi
rm -rf $TMPDIR
exit 0